#include "partition.h"
#include <bits/stdc++.h>
using namespace std;
long long s=0,sum=0,mn=1e18;
pair <int,int> a[2*1048576];
int n,p[30],used[2*1048576];
vector <int> ans;
void print()
{
    vector <int> v;
    v.clear();
    long long br=0,sum1=0,s1=0;
    for(long long i=0; i<n; i++)
    {
        if(p[i]==1)
        {
            sum1+=a[i].first;
            br++;
            if(sum1>=s/2+s%2)
            {
                if(mn>abs(br-(n-br)))
                {
                    mn=abs(br-(n-br));
                    ans.clear();
                    for(int j=0;j<=i;j++)
                    {
                        if(p[j]==1)ans.push_back(a[j].second);
                    }
                }
                return;
            }
        }
    }
}
void rek(long long pos)
{
    for(long long i=0; i<2; i++)
    {
        p[pos]=i;
        if(pos==n-1)print();
        else rek(pos+1);
    }
}
vector<int> solve(vector<int> A)
{
    mn=1e18;
    s=0;
    sum=0;
    n=A.size();
    int p1=0,p2=n-1;
    for(long long i=0; i<n; i++)
    {
        a[i]={A[i],i};
        s+=a[i].first;
        used[i]=0;
        p[i]=0;
    }
    sort(a,a+n);
    rek(0);
    for(auto i:ans)used[i]=1;
    for(long long i=0; i<n; i++)
    {
        if(!used[i])ans.push_back(i);
    }
    return ans;
}
